#include <BtLib.h>
#include <BtLibTypes.h>
#include <BtCommVdrv.h>

#include "BluetoothComm.h"
#include "BtAppLib.h"

// returns the opened bluetooth port if needed
UInt16 getBtPort()
{
	UInt32 port = 0;

	FtrGet(appFileCreator, 9811, &port);
	
	return port;
}

// this starts the bluetooth stack as client
Err startBluetoothStack()
{
	Err returnCode = 0;
	UInt16 port = 0;
	
	SrmOpenConfigType config;
	BtVdOpenParams btParams;
	BtLibSdpUuidType sppUuid;
	
	MemSet( &sppUuid, sizeof(sppUuid), 0 );
	sppUuid.size = btLibUuidSize16;
	sppUuid.UUID[0] = 0x11;
	sppUuid.UUID[1] = 0x01;
	
	MemSet( &btParams, sizeof(btParams), 0 );
	btParams.role = btVdClient;
	btParams.u.client.method = btVdUseUuidList;
	btParams.u.client.u.uuidList.tab = &sppUuid;
	btParams.u.client.u.uuidList.len = 1;
	
	MemSet( &config, sizeof(config), 0 );
	config.function = 0;
	config.drvrDataP = (MemPtr)&btParams;
	config.drvrDataSize = sizeof(btParams);

	returnCode = SrmExtOpen(
			sysFileCVirtRfComm,
			&config,
			sizeof(config),
			&port
			);
			
	FtrSet(appFileCreator, 9811, port);

	return returnCode;
}