#include "SrAppLib.h"
#include "BtAppLib.h"
#include "BluetoothComm_Rsc.h"
#include "BluetoothComm.h"
#include "BtAppLib.h"
#include "UiAppLib.h"

// This function reads the data, 
// which are received via bluetooth und returns it
Char* ReadSerial() {

  static Char buffer[100];
  static UInt16 index = 0;
  Err error;
  UInt32 bytes;
  UInt16 btPort;
  
  btPort = getBtPort();
  
  error = SrmReceiveCheck(btPort, & bytes);  
  if(error){
  
  	setErrorExit(error);
  
    ClearField(MainForm, DialogField);
	WriteInDialogField(MainForm, DialogField, "Error while receiving data!");

	handleConnectionLost(BtErrorOccurredAlert2);
	
	return NULL;
  }  
  
  if (bytes + index > sizeof(buffer)) {
    bytes = sizeof(buffer) - index -
      sizeOf7BitChar(\0);
  }

  while (bytes) {
    SrmReceive(btPort, & buffer[index], 1, 0, &error);
    if (error) {
      SrmReceiveFlush(btPort, 1);
      index = 0;
      return NULL;
    }
    switch (buffer[index]) {
    case chrCarriageReturn:
      buffer[index] = chrLineFeed;
    case chrLineFeed:
      buffer[index + 1] = chrNull;
      index = 0;
      return buffer;
      break;
    default:
      index++;
      break;
    }
    bytes--;
  }
  
  return NULL;
  
}


// This function sends text over the serial-(bluetooth)-interface
void SendDataSerial(void *value){

    Err error;
    UInt16 btPort;

	btPort = getBtPort();

    SrmReceiveFlush(btPort, 0);
    SrmSend(btPort, value, StrLen(value), &error);
    SrmSend(btPort, "\n", 1, &error);
        
    if(error){
    
    	setErrorExit(error);

    	ClearField(MainForm, DialogField);
    	WriteInDialogField(MainForm, DialogField, "Error while sending data!");
    
    	handleConnectionLost(BtErrorOccurredAlert2);
    }   
}
