#include "UiAppLib.h"
#include "BluetoothComm_Rsc.h"
#include "BtAppLib.h"
#include "BluetoothComm.h"

// This function handles a lost connection and offers are reconnect and exit
UInt16 handleConnectionLost(UInt16 alertID){
	
	UInt16 tappedButton;
	UInt16 btPort;
	
	btPort = getBtPort();
	tappedButton = FrmAlert(alertID);
	
	if(tappedButton == 0){
		//Reconnect
		ClearField(MainForm, DialogField);
		WriteInDialogField(MainForm, DialogField, "Restarting bluetooth stack...");
		SrmClose(btPort);
		startBluetoothStack();
		ClearField(MainForm, DialogField);
		WriteInDialogField(MainForm, DialogField, "Please select a data point.");
		setErrorExit(0);
	}
	
	if(tappedButton == 1){
		// Exit
		ClearField(MainForm, DialogField);
		WriteInDialogField(MainForm, DialogField, "Shutting down bluetooth stack...");
		setErrorExit(1);
	}
	
	return tappedButton;
}


// This function clears a field, primary used to clear the DialogField
Boolean ClearField(UInt16 formID, UInt16 fieldID)
{
	FormPtr 	formPtr;
	UInt16		objectIndex;
	FieldPtr	fieldPtr;
	UInt16 		length;
	Boolean 	handled = false;
	
	
	formPtr = FrmGetFormPtr(formID);
	objectIndex = FrmGetObjectIndex(formPtr, fieldID);
	fieldPtr = (FieldPtr)FrmGetObjectPtr(formPtr, objectIndex);
	length = FldGetTextLength(fieldPtr); 
	
	if(fieldID == DialogField){
		FldSetTextPtr(fieldPtr, "");
		FldDrawField(fieldPtr);
	}else{
		FldDelete(fieldPtr,0,length);
	}
	
    handled = true;
    
	return handled;
}

// This function writes a String into a (Dialog)Field
Boolean WriteInDialogField(UInt16 formID, UInt16 fieldID, MemPtr str)
{
	FormPtr 	formPtr;
	UInt16		objectIndex;
	FieldPtr	fieldPtr;
	
	char* dialogStrPtr;
	char* newDialogStrPtr;
	

	Boolean 	handled = false;
	
	formPtr = FrmGetFormPtr(formID);
	objectIndex = FrmGetObjectIndex(formPtr, fieldID);
	fieldPtr = (FieldPtr)FrmGetObjectPtr(formPtr, objectIndex);
	
	dialogStrPtr = FldGetTextPtr(fieldPtr);
	
	if(dialogStrPtr){
		newDialogStrPtr = MemPtrNew((StrLen(dialogStrPtr)+StrLen(str)+1));
	
		StrCopy(newDialogStrPtr, dialogStrPtr);
    	StrCat(newDialogStrPtr, str);
		FldSetTextPtr(fieldPtr, newDialogStrPtr);
		FldRecalculateField(fieldPtr, true);
	}else{
		FldSetTextPtr(fieldPtr, str);
	}
	
	FldDrawField(fieldPtr);
	
    handled = true;
    
	return handled;
}